diff --git a/target-mips/translate.c b/target-mips/translate.c
index cefccb0..590c2b6 100644
--- a/target-mips/translate.c
+++ b/target-mips/translate.c
@@ -8540,53 +8501,52 @@ static void mips_tcg_init(void)
     if (inited)
 	return;
 
-    cpu_env = tcg_global_reg_new(TCG_TYPE_PTR, TCG_AREG0, "env");
+    cpu_env = tcg_global_reg_new_ptr(TCG_AREG0, "env");
     for (i = 0; i < 32; i++)
-        cpu_gpr[i] = tcg_global_mem_new(TCG_TYPE_TL, TCG_AREG0,
+        cpu_gpr[i] = tcg_global_mem_new(TCG_AREG0,
                                         offsetof(CPUState, active_tc.gpr[i]),
                                         regnames[i]);
-    cpu_PC = tcg_global_mem_new(TCG_TYPE_TL, TCG_AREG0,
+    cpu_PC = tcg_global_mem_new(TCG_AREG0,
                                 offsetof(CPUState, active_tc.PC), "PC");
     for (i = 0; i < MIPS_DSP_ACC; i++) {
-        cpu_HI[i] = tcg_global_mem_new(TCG_TYPE_TL, TCG_AREG0,
+        cpu_HI[i] = tcg_global_mem_new(TCG_AREG0,
                                        offsetof(CPUState, active_tc.HI[i]),
                                        regnames_HI[i]);
-        cpu_LO[i] = tcg_global_mem_new(TCG_TYPE_TL, TCG_AREG0,
+        cpu_LO[i] = tcg_global_mem_new(TCG_AREG0,
                                        offsetof(CPUState, active_tc.LO[i]),
                                        regnames_LO[i]);
-        cpu_ACX[i] = tcg_global_mem_new(TCG_TYPE_TL, TCG_AREG0,
+        cpu_ACX[i] = tcg_global_mem_new(TCG_AREG0,
                                         offsetof(CPUState, active_tc.ACX[i]),
                                         regnames_ACX[i]);
     }
-    cpu_dspctrl = tcg_global_mem_new(TCG_TYPE_TL, TCG_AREG0,
+    cpu_dspctrl = tcg_global_mem_new(TCG_AREG0,
                                      offsetof(CPUState, active_tc.DSPControl),
                                      "DSPControl");
-    bcond = tcg_global_mem_new(TCG_TYPE_I32, TCG_AREG0,
-                               offsetof(CPUState, bcond), "bcond");
-    btarget = tcg_global_mem_new(TCG_TYPE_TL, TCG_AREG0,
+    bcond = tcg_global_mem_new_i32(TCG_AREG0,
+                                   offsetof(CPUState, bcond), "bcond");
+    btarget = tcg_global_mem_new(TCG_AREG0,
                                  offsetof(CPUState, btarget), "btarget");
     for (i = 0; i < 32; i++)
-        fpu_fpr32[i] = tcg_global_mem_new(TCG_TYPE_I32, TCG_AREG0,
-                                          offsetof(CPUState, active_fpu.fpr[i].w[FP_ENDIAN_IDX]),
-                                          fregnames[i]);
+        fpu_fpr32[i] = tcg_global_mem_new_i32(TCG_AREG0,
+            offsetof(CPUState, active_fpu.fpr[i].w[FP_ENDIAN_IDX]),
+            fregnames[i]);
     for (i = 0; i < 32; i++)
-        fpu_fpr64[i] = tcg_global_mem_new(TCG_TYPE_I64, TCG_AREG0,
-                                          offsetof(CPUState, active_fpu.fpr[i]),
-                                          fregnames_64[i]);
+        fpu_fpr64[i] = tcg_global_mem_new_i64(TCG_AREG0,
+            offsetof(CPUState, active_fpu.fpr[i]),
+            fregnames_64[i]);
     for (i = 0; i < 32; i++)
-        fpu_fpr32h[i] = tcg_global_mem_new(TCG_TYPE_I32, TCG_AREG0,
-                                           offsetof(CPUState, active_fpu.fpr[i].w[!FP_ENDIAN_IDX]),
-                                           fregnames_h[i]);
-    fpu_fcr0 = tcg_global_mem_new(TCG_TYPE_I32, TCG_AREG0,
-                                   offsetof(CPUState, active_fpu.fcr0),
-                                   "fcr0");
-    fpu_fcr31 = tcg_global_mem_new(TCG_TYPE_I32, TCG_AREG0,
-                                   offsetof(CPUState, active_fpu.fcr31),
-                                   "fcr31");
+        fpu_fpr32h[i] = tcg_global_mem_new_i32(TCG_AREG0,
+            offsetof(CPUState, active_fpu.fpr[i].w[!FP_ENDIAN_IDX]),
+            fregnames_h[i]);
+    fpu_fcr0 = tcg_global_mem_new_i32(TCG_AREG0,
+                                      offsetof(CPUState, active_fpu.fcr0),
+                                      "fcr0");
+    fpu_fcr31 = tcg_global_mem_new_i32(TCG_AREG0,
+                                       offsetof(CPUState, active_fpu.fcr31),
+                                       "fcr31");
 
     /* register helpers */
-#undef DEF_HELPER
-#define DEF_HELPER(ret, name, params) tcg_register_helper(name, #name);
+#define GEN_HELPER 2
 #include "helper.h"
 
     inited = 1;
